import java.net.*;

import java.io.*;

import java.security.*;





public class FileDigest {



  public static void main(String[] args) {



    if (args.length != 2) {

      System.err.println("Utilizzo: java FileDigest <url> <nomefile>");

      return;

    }



    try {

      URL u = new URL(args[0]);

      FileOutputStream fos = new FileOutputStream(args[1]);

      copyFileWithDigest(u.openStream(), fos);

      fos.close();

    }

    catch (MalformedURLException e) {

      System.err.println("Il parametro"+ args[0] + " non rappresenta un  URL corretto");
    }

    catch (Exception e) {

      System.err.println(e);

    }



  }




public static void DigestCopyFile (InputStream in, OutputStream out) 
throws IOException, NoSuchAlgorithmException {

    

     MessageDigest sha_digest = MessageDigest.getInstance("SHA");

     DigestOutputStream dos = new DigestOutputStream(out, sha_digest);

     byte[] data = new byte[128];

     for (;;) {

       int bytes = in.read(data);

       if (bytes < 0) break;

       dos.write(data, 0, bytes);

     }

     dos.flush();

     byte[] result = dos.getMessageDigest().digest();

     for (int i = 0; i < result.length; i++) {

       System.out.print(result[i] + " ");

     }

     System.out.println("\n");

     

  }



}

