import java.security.*;

import java.io.*;

import java.util.*;



public class SignFile {

  public static void main(String[] args) {

    try {




      IdentityScope scope = IdentityScope.getSystemScope();



      Identity identity = scope.getIdentity("usingjava");



      // Crea una Signature  e la inizializza per creare una firma  

      Signature sig = Signature.getInstance("DSA", "SUN");

      Signer signer = (Signer) identity;

      sig.initSign(signer.getPrivateKey());



      // Apre il file che deve essere firmato
      FileInputStream infile = new FileInputStream("SignFile.java");



      // Legge i byte dal file e li aggiunge al buffer della Signature

      int i;

      while ((i = infile.read()) >= 0) {

        sig.update((byte)i);

      }



      infile.close();



      // Apre il file dove scrivere la firma digitale del file in input
      FileOutputStream outfile = new FileOutputStream(
"SignFile.sig");

      // Genera e scrive la firma
      outfile.write(sig.sign());

      outfile.close();



    } catch (Exception e) {

      e.printStackTrace();

    }

  }

}

